<?php
/* -----------------------------------------------------------------
 * 	$Id: blog.php 612 2013-09-17 16:36:53Z akausch $
 * 	Copyright (c) 2011-2021 commerce:SEO by Webdesign Erfurt
 * 	http://www.commerce-seo.de
 * ------------------------------------------------------------------
 * 	based on:
 * 	(c) 2000-2001 The Exchange Project  (earlier name of osCommerce)
 * 	(c) 2002-2003 osCommerce - www.oscommerce.com
 * 	(c) 2003     nextcommerce - www.nextcommerce.org
 * 	(c) 2005     xt:Commerce - www.xt-commerce.com
 * 	Released under the GNU General Public License
 * --------------------------------------------------------------- */

require('includes/application_top.php');

require_once (DIR_WS_CLASSES . '/blog.php');
require_once(DIR_FS_INC . 'xtc_js_lang.php');

if (MODULE_COMMERCE_SEO_INDEX_STATUS == 'True') {
    require_once (DIR_FS_INC . 'commerce_seo.inc.php');
    !$commerceSeo ? $commerceSeo = new CommerceSeo() : false;
}

$comment_count = xtc_db_fetch_array(xtc_db_query("SELECT COUNT(*) as count FROM " . TABLE_BLOG_COMMENT . " WHERE comment_status = '0'"));

if ($_GET['action']) {
    switch ($_GET['action']) {

        case 'save_category' :
            blogCategories($_POST, $_POST['action']);
            if (MODULE_COMMERCE_SEO_INDEX_STATUS == 'True')
                $commerceSeo->createSeoDBTable();
            xtc_redirect(xtc_href_link(FILENAME_BLOG));
            break;

        case 'set' :
            SetFlag($_POST, $_GET);
            if ((int) $_GET['cat'])
                xtc_redirect(xtc_href_link(FILENAME_BLOG, 'action=showitems&cat=' . (int) $_GET['cat']));
            else
                xtc_redirect(xtc_href_link(FILENAME_BLOG));
            break;

        case 'save_item' :
            blogItem($_POST, $_POST['action']);
            if (MODULE_COMMERCE_SEO_INDEX_STATUS == 'True')
                $commerceSeo->createSeoDBTable();
            xtc_redirect(xtc_href_link(FILENAME_BLOG, 'action=showitems&cat=' . $_POST['categories_id']));
            break;

        case 'save_start' :
            blogStart($_POST, $_POST['action']);
            xtc_redirect(xtc_href_link(FILENAME_BLOG));
            break;

        case 'settings':
        case 'blog_setting':
			if($_GET['action'] == 'blog_setting') {
				$save_value_query = xtc_db_query("SELECT blog_key, wert FROM " . TABLE_BLOG_SETTINGS . "");
				while ($save_value = xtc_db_fetch_array($save_value_query)) {
					xtc_db_query("UPDATE " . TABLE_BLOG_SETTINGS . " SET wert = '" . $_POST[$save_value['blog_key']] . "' WHERE blog_key='" . $save_value['blog_key'] . "'");
				}
				$success = SAVE_SUCCESS;
			}
			$alle_values = array();
			$values_query = xtc_db_query("SELECT blog_key, wert FROM ".TABLE_BLOG_SETTINGS." ORDER BY id ASC ");
			while($values_data = xtc_db_fetch_array($values_query)) {
				if($values_data['wert']=='ja' ? $checked_ja = 'checked=""' : $checked_ja = '');
				if($values_data['wert']=='nein' ? $checked_nein = 'checked=""' : $checked_nein = '');
				$alle_values[] = array('blog_key' => $values_data['blog_key'], 'wert' => $values_data['wert'], 'ja' => $checked_ja, 'nein' => $checked_nein);
			}
        break;
    }
}

require(DIR_WS_INCLUDES . 'header.php');
?>

<script type="text/javascript">
function checkboxes(wert) {
	var my = document.leiste;
	var len = my.length;

	for (var i = 0; i < len; i++) {
		var e = my.elements[i];
		if (e.name == "status[]") {
			e.checked = wert;
		}
	}
}
</script>
<?php 
if (USE_WYSIWYG == 'true') {
?>
<script src="includes/editor/ckeditor/ckeditor.js" type="text/javascript"></script>
<?php
if (file_exists('includes/editor/ckfinder/ckfinder.js')) {
    echo '<script src="includes/editor/ckfinder/ckfinder.js" type="text/javascript"></script>';
}
}
?>
<table class="outerTable" cellpadding="0" cellspacing="0">
    <tr>
        <td class="boxCenter" width="100%" valign="top">
            <table class="table_pageHeading" border="0" width="100%" cellspacing="0" cellpadding="0">
                <tr>
                    <td class="pageHeading"><?php echo HEADING_TITLE_BLOG; ?></td>
                </tr>
            </table>
            <table class="table_pageHeading" border="0" cellspacing="0" cellpadding="5" width="100%">
                <tr>
                    <td align="right">
                        <a class="button" href="<?php echo xtc_href_link(FILENAME_BLOG); ?>"><?php echo TABLE_HEADING_NAVIGATION_OVERVIEW; ?></a>
                        <a class="button" href="<?php echo xtc_href_link(FILENAME_BLOG, 'action=newcategorie'); ?>"><?php echo TABLE_HEADING_NAVIGATION_NEWCATEGORIE; ?></a>
                        <a class="button" href="<?php echo xtc_href_link(FILENAME_BLOG, 'action=startsite'); ?>"><?php echo TABLE_HEADING_NAVIGATION_STARTSITE; ?></a>
                        <a class="button" href="<?php echo xtc_href_link(FILENAME_BLOG, 'action=settings'); ?>"><?php echo TABLE_HEADING_NAVIGATION_SETTINGS; ?></a>
                        <a class="button" href="<?php echo xtc_href_link(FILENAME_BLOG, 'action=comments'); ?>"><?php echo TABLE_HEADING_NAVIGATION_COMMENTS; ?>
						<?php
						if ($comment_count['count'] > 0) {
							echo '&nbsp;<b class="numberRed">' . $comment_count['count'] . '</b>';
						}
						?>
						</a>
                    </td>
                </tr>
            </table>
        </td>
    </tr>
</table>
<?php

switch ($_GET['action']) {
    case 'newcategorie' :
    case 'editcategories' :
        include(DIR_WS_MODULES . 'blog_categories_edit.php');
        break;

    case 'startsite' :
        include(DIR_WS_MODULES . 'blog_start.php');
        break;

    case 'edit_item' :
    case 'new_item' :
        include(DIR_WS_MODULES . 'blog_item_edit.php');
        break;

    case 'showitems' :
        include(DIR_WS_MODULES . 'blog_item_list.php');
        break;

    case 'settings' :
		include(DIR_WS_MODULES.'blog_settings.php');
		break;

    default :
        include(DIR_WS_MODULES . 'blog_categories_list.php');
        break;
}
require(DIR_WS_INCLUDES . 'footer.php');
require(DIR_WS_INCLUDES . 'application_bottom.php');
